<template>
  <div class="content">
    <div class="intro-y flex flex-col sm:flex-row items-center my-8">
      <div class="mr-auto">
        <h2 class="text-lg font-medium mr-auto">Form Holiday</h2>
      </div>
    </div>
    <div class="grid grid-cols-12 gap-6 mt-5">
      <div class="intro-y col-span-12 lg:col-span-6">
        <!-- BEGIN: Form Layout -->
        <div class="intro-x box p-5">
          <form @submit.prevent="submit">
            <div>
              <label for="crud-form-1" class="form-label">Name</label>
              <input
                id="crud-form-1"
                type="text"
                class="form-control w-full"
                v-model="name"
                placeholder="Input Name"
              />
            </div>
            <div>
              <label for="crud-form-1" class="form-label mt-2">Category</label>
              <select
                class="tom-select w-full"
                v-model="category"
                data-placeholder="Select Category"
              >
                <option
                  v-for="item in categories"
                  :value="item"
                  :key="item"
                  :selected="item === category"
                >
                  {{ item }}
                </option>
              </select>
            </div>

            <div>
              <label for="crud-form-1" class="form-label mt-2"
                >Holiday Date</label
              >
              <Datepicker
                v-model="holiday_date"
                class="form-control"
                placeholder="Event Date ..."
                textInput
                range
              />
            </div>

            <div class="text-right mt-5">
              <a href="/holiday" class="btn btn-outline-secondary w-24 mr-1"
                >Cancel</a
              >
              <button type="submit" class="btn btn-primary w-24">
                {{ label }}
              </button>
            </div>
          </form>
        </div>
        <!-- END: Form Layout -->
      </div>
    </div>
  </div>
</template>

<script>
import Toastify from "toastify-js";
import { ref } from "vue";

export default {
  name: "FormHoliday",
  data() {
    return {
      name: "",
      category: "",
      categories: [],
      holiday_date: ref(),
      edit: false,
      label: "Save",
      fieldEmpty: [],
      error: "",
      id: 0,
    };
  },
  watch: {
    department() {
      this.getUser();
    },
  },
  created: function () {
    var splitUrl = this.$route.path.split("/");
    if (splitUrl[1] == "edit-holiday") {
      this.edit = true;
      this.id = splitUrl[2];
      this.label = "Edit";
    }
  },
  methods: {
    async getCategory() {
      const res = await this.$axios.get("/category/code", {
        headers: {
          Token: this.$store.state.user.token,
          "User-ID": this.$store.state.user.user_id,
        },
      });
      let data = res.data.data;

      for (let x = 0; x < data.length; x++) {
        const element = data[x];
        this.categories.push(element.name);
      }
    },
    async getDetail() {
      this.$axios
        .get(`/holiday/${this.id}/detail`, {
          headers: {
            Token: this.$store.state.user.token,
            "User-ID": this.$store.state.user.user_id,
          },
        })
        .then((response) => {
          const data = response.data.data;
          this.name = data.name;
          this.category = data.Category;
          const startDate = new Date(data.holiday_date);
          this.holiday_date = [startDate];
        })
        .catch((error) => {
          console.log(error);
        });
    },
    submit: function () {
      const name = this.name;
      const holidayDate = new Date(this.holiday_date);
      const category = this.category;
      const startYear = holidayDate.getUTCFullYear();
      const startMonth =
        holidayDate.getUTCMonth() + 1 > 9
          ? (holidayDate.getUTCMonth() + 1).toString()
          : "0" + (holidayDate.getUTCMonth() + 1).toString();
      const startDay =
        holidayDate.getUTCDate() > 9
          ? holidayDate.getUTCDate().toString()
          : "0" + holidayDate.getUTCDate().toString();
      const startDate = `${startYear}-${startMonth}-${startDay}`;
      const body = {
        name: name,
        category: category,
        holiday_date: startDate,
      };

      if (name == "") {
        this.fieldEmpty.push("name");
      }

      if (category == "") {
        this.fieldEmpty.push("category");
      }

      if (this.holiday_date == undefined) {
        this.fieldEmpty.push("start date");
      }

      if (this.fieldEmpty.length > 0) {
        this.error = this.fieldEmpty.join(" & ");
        this.error += ` is empty`;
        Toastify({
          text: `ERROR : ${this.error}`,
          duration: 3000,
          newWindow: true,
          close: true,
          gravity: "top",
          position: "right",
          stopOnFocus: true,
          className: "toastify-content",
        }).showToast();

        this.fieldEmpty = [];
        this.error = "";
        return;
      }

      if (this.edit) {
        this.$axios
          .put(`/holiday/${this.id}/update`, body, {
            headers: {
              Token: this.$store.state.user.token,
              "User-ID": this.$store.state.user.user_id,
            },
          })
          .then(() => {
            Toastify({
              text: `Update Holiday Success`,
              duration: 3000,
              newWindow: true,
              close: true,
              gravity: "top",
              position: "right",
              stopOnFocus: true,
              className: "toastify-content",
            }).showToast();
            this.$router.push({
              name: "data-holiday",
            });
          })
          .catch((error) => {
            Toastify({
              text: `ERROR : ${error.response.data.message}`,
              duration: 3000,
              newWindow: true,
              close: true,
              gravity: "top",
              position: "right",
              stopOnFocus: true,
              className: "toastify-content",
            }).showToast();
          });
      } else {
        this.$axios
          .post("/holiday", body, {
            headers: {
              Token: this.$store.state.user.token,
              "User-ID": this.$store.state.user.user_id,
            },
          })
          .then(() => {
            Toastify({
              text: `Create Holiday Success`,
              duration: 3000,
              newWindow: true,
              close: true,
              gravity: "top",
              position: "right",
              stopOnFocus: true,
              className: "toastify-content",
            }).showToast();
            this.$router.push({
              name: "data-holiday",
            });
          })
          .catch((error) => {
            Toastify({
              text: `ERROR : ${error.response.data.message}`,
              duration: 3000,
              newWindow: true,
              close: true,
              gravity: "top",
              position: "right",
              stopOnFocus: true,
              className: "toastify-content",
            }).showToast();
          });
      }
    },
  },
  mounted() {
    this.getCategory();
    if (this.edit) {
      this.getDetail();
    }
  },
};
</script>
